// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")

void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

int main(int argc, char* argv[])
{

	DWORD dwRet;
	DWORD dwCount=0;
	ET_CONTEXT *pContext;

	BYTE pbOut[256] = {0};
	BYTE pbIN[256] = {0};
	DWORD dwOutLen = 0;
	DWORD i=0;

	
	//öET199
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;

	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		ETClose(&pContext[0]);
		delete [] pContext;
		return dwRet;
	}

	//ǩ0001ִļ
	BYTE pbPlainText[] = "123456";
	BYTE pbSignResult[128] = {0};

	dwRet = ETExecute(&pContext[0], "0001", pbPlainText, lstrlen((char*)pbPlainText), pbSignResult, 128, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error:0x%08X\n",dwRet);
		ETClose(&pContext[0]);
		delete [] pContext;
		return dwRet;
	}
	
	if(128 != dwOutLen)
	{
		printf("Sign Error:0x%08X\n",dwRet);
		ETClose(&pContext[0]);
		delete [] pContext;
		return dwRet;
	}

	printf("\nSign Result:\n");
	for(i=0; i<128; ++i)
	{
		printf("%02X ", pbSignResult[i]);

		if((i+1)%16 == 0)
			printf("\n");
	}


	//֤ǩ0002ִļ
	BYTE pbInBuffer[1024] = {0};
	BYTE bPlainLen = (BYTE)lstrlen((char*)pbPlainText);
	memcpy(pbInBuffer, &bPlainLen, 1);
	memcpy(pbInBuffer+1, pbPlainText, bPlainLen);
	memcpy(pbInBuffer+1+bPlainLen, pbSignResult, 128);
	
	printf("\nVeriSign Result:\n");
	
	memset(pbSignResult, 0, 128);
	dwRet = ETExecute(&pContext[0], "0002", pbInBuffer, 1+bPlainLen+128, pbSignResult, 128, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error:0x%08X\n",dwRet);
		ETClose(&pContext[0]);
		delete [] pContext;
		return dwRet;
	}

	if(0 == pbSignResult[0])
	{
		printf("VeriSign Success!\n");
	}
	else
	{
		printf("VeriSign Fail! Error: 0x%02X\n", pbSignResult[0]);
	}


	ETClose(&pContext[0]);
	delete [] pContext;
	
	return 0;
}
